<?xml version="1.0"?>

<xsl:stylesheet   version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output 
    method="xml" encoding="UTF-8" indent="yes"
    doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"
    doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" />

<xsl:template match="/">
    <html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta name="description" content="Some messages"/>
	<title>Messages</title>
    </head>
    <body>
<!--   <xsl:apply-templates/>-->
   <table border="1">
     <tr><td>ID</td><td>Channel</td><td>Text</td></tr>
     <xsl:apply-templates select="./messages/message"/>
<!--    <xsl:for-each select="./messages/message">
            <tr>
                <td><xsl:value-of select="@uniqueId"/></td>
                <td><xsl:value-of select="@channel"/></td>
                <td><xsl:value-of select="text()"/></td>
            </tr>
        </xsl:for-each>-->
   </table>
   <xsl:apply-templates select="./messages/messagePath"/>
   <h2>Favorite messages</h2>
   <table border="1">
   <xsl:for-each select="//favoriteMessages/message">
       <xsl:apply-templates select="//messages/message[@uniqueId=current()/@id]"/>
   </xsl:for-each>
   </table>
    </body>
   </html>
</xsl:template>


<xsl:template match="message">
  <tr>
    <td>
      
     <xsl:choose>
        <xsl:when test="//favoriteMessages/message[@id=current()/@uniqueId]">
          <xsl:element name="b">
              <xsl:value-of select="@uniqueId"/>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
             <xsl:value-of select="@uniqueId"/>
        </xsl:otherwise>
      </xsl:choose>
      
    </td>
    <td><xsl:value-of select="@channel"/></td>
    <td><xsl:value-of select="text()"/></td>
  </tr>
</xsl:template>

<xsl:template match="messagePath">
  <br/>
  <b> Message path <xsl:value-of select="@msgId"/> with <xsl:value-of select="count(./node)"/> nodes.</b> 
   <xsl:apply-templates/>
</xsl:template>

<xsl:template match="node">
  <!--<xsl:variable name="nodeId" select="@id"/>-->  
  <xsl:apply-templates select="/messages/nodes/nodeDescription[@id=current()/@id]"/>
  <!--<xsl:apply-templates select="/messages/nodes/nodeDescription[@id=$nodeId]"/>-->
</xsl:template>

<xsl:template match="nodeDescription">
  <xsl:value-of select="./name"/>
</xsl:template>

</xsl:stylesheet>